import React, { Component } from 'react-native';
import { createStore, applyMiddleware, combineReducers } from 'redux';
import { Provider } from 'react-redux';
import thunk from 'redux-thunk';

import * as reducers from './reducers';

import Root from './Root';

const createStoreWithMiddleware = applyMiddleware(thunk,logger)(createStore);

const reducer = combineReducers(reducers);

const store = createStoreWithMiddleware(reducer);

export default class App extends Component {

  render() {
    return (
      <Provider store={store}>
        <Root/>
      </Provider>
    );
  }

}

function logger(_ref) {
  var dispatch = _ref.dispatch;
  var getState = _ref.getState;

  return function (next) {
    return function (action) {
      console.log(action.type);
      //console.log(getState());
      return next(action);
    };
  };
}