
import React, {
  Component,
  Text,
  View,
  ScrollView,
  StyleSheet,
  TouchableOpacity,
} from 'react-native';

import { connect } from 'react-redux'
import {fetchCommentListIfNeeded,} from './actions';

const styles = StyleSheet.create({
  container: {
    flex:1,
    paddingTop: 20,
  },
  row: {
    backgroundColor:'white',
    height: 50,
    //alignItems: 'center',
    paddingLeft:20,
    justifyContent: 'center',
    borderBottomColor:'grey',
    borderBottomWidth:1,
  },
  header:{
    height:44,
    flexDirection:'row'
  },
  button:{
    width:60,
    alignItems:'center',
    justifyContent:'center',
  },
});

class Comment extends Component {
  constructor(props) {
    super(props);
    this.state = {};
  }

  componentDidMount() {
    this.props.dispatch(fetchCommentListIfNeeded(this.props.post.id));
  }

  renderList(list) {
    let result = [];
    list.map(i => {
      result.push(<View key={i.id} style={styles.row}><Text>{i.title}</Text></View>);
    });
    return result;
  }

  render() {
    let {isFetching, list, post} = this.props;
    console.log('@@Render CommentList for post:', post.id)
    return (
      <View style={styles.container}>
        <View style={styles.header}>
          <TouchableOpacity style={styles.button} onPress={() => this.props.navigator.pop()}>
            <Text style={{color:'blue', fontSize:18}}>Back</Text></TouchableOpacity>
          <View style={{flex:1}}></View>
        </View>
        {isFetching && <View style={{flex:1, alignItems:'center', justifyContent:'center'}}><Text>loading</Text></View>}
        <ScrollView style={{flex: 1}}>
          {!isFetching && list && this.renderList(list)}
        </ScrollView>
      </View>
    );
  }
}


function mapStateToProps(state, ownProps) {
  let {listByPost} = state.commentList;
  let {post} = ownProps;
  let {list, isFetching} = listByPost[post.id] || {isFetching:true};
  return {
    isFetching,
    list,
  };
}

export default connect(mapStateToProps)(Comment)