
import React, {
  Component,
  Text,
  View,
  ScrollView,
  StyleSheet,
  TouchableOpacity,
} from 'react-native';

import { connect } from 'react-redux'
import {fetchPostListIfNeeded} from './actions';
import Comment from './Comment';

const styles = StyleSheet.create({
  container: {
    flex:1,
    paddingTop: 20,
  },
  row: {
    backgroundColor:'white',
    height: 50,
    //alignItems: 'center',
    paddingLeft:20,
    justifyContent: 'center',
    borderBottomColor:'grey',
    borderBottomWidth:1,
  }
});

class Post extends Component {
  constructor(props) {
    super(props);
    this.state = {};
    this.handlePress = this.handlePress.bind(this);
  }

  componentDidMount() {
    this.props.dispatch(fetchPostListIfNeeded());
  }
  
  handlePress(post) {
    this.props.navigator.push({
      component: Comment,
      passProps: { post: post},
    });
  }
  
  renderList(list) {
    let result = [];
    list.map(i => {
      result.push(<TouchableOpacity onPress={() => this.handlePress(i)} key={i.id} style={styles.row}><Text>{i.title}</Text></TouchableOpacity>);
    });
    return result;
  }
  
  render() {
    console.log('@@Render PostList')
    let {isFetching, list} = this.props;
    return (
      <View style={styles.container}>
        {isFetching && <View style={{flex:1, alignItems:'center', justifyContent:'center'}}><Text>loading</Text></View>}
        <ScrollView style={{flex: 1}}>
          {!isFetching && list && this.renderList(list)}
        </ScrollView>
      </View>
    );
  }
}


function mapStateToProps(state, ownProps) {
  let {list, isFetching} = state.postList || {isFetching:true};
  return {
    isFetching,
    list
  };
}

export default connect(mapStateToProps)(Post)