'use strict'

export const REQUEST_POST_LIST  = 'REQUEST_POST_LIST';
export const RECEIVE_POST_LIST  = 'RECEIVE_POST_LIST';

export const REQUEST_COMMENT_LIST = 'REQUEST_COMMENT_LIST';
export const RECEIVE_COMMENT_LIST = 'RECEIVE_COMMENT_LIST';


export function requestPostList() {
  return {
    type: REQUEST_POST_LIST,
  }
}

export function receivePostList(data) {
  return {
    type: RECEIVE_POST_LIST,
    data: data,
  }
}

export function fetchPostList() {
  return dispatch => {
    dispatch(requestPostList());
    setTimeout(() => {
      let posts = [];
      for (let i = 0; i < 100; i ++) {
        posts.push({id:i, title: `title of ${i}`});
      }
      dispatch(receivePostList(posts));
    }, 500);
  }
}

export function fetchPostListIfNeeded(tab) {
  return  (dispatch, getState) => {
    if (!getState().postList.data) {
      return dispatch(fetchPostList());
    }
  }
}

export function requestCommentList(post) {
  return {
    type: REQUEST_COMMENT_LIST,
    post: post,
  }
}

export function receiveCommentList(post, data) {
  return {
    type: RECEIVE_COMMENT_LIST,
    post: post,
    data: data,
  }
}

export function fetchCommentList(post) {
  return dispatch => {

    dispatch(requestCommentList(post));
    setTimeout(() => {
      let comments = [];
      for (let i = 0; i < 10; i ++) {
        comments.push({id:i, title: `title of comment ${i} for post ${post}`});
      }
      dispatch(receiveCommentList(post, comments));
    }, 500);
    
  }

}

export function fetchMoreCommentList(post) {
  return (dispatch, getState) => {
    return dispatch(fetchCommentList(post));
  }
}

export function fetchCommentListIfNeeded(post) {
  return  (dispatch, getState) => {
    if (!getState().commentList.listByPost[post]) {
      return dispatch(fetchCommentList(post));
    }
  }
}