import * as types from './actions';
import { combineReducers } from 'redux';

function listByPost(state = {}, action) {
  switch (action.type) {
    case types.RECEIVE_COMMENT_LIST:
    case types.REQUEST_COMMENT_LIST:
      return Object.assign({}, state, {
        [action.post]: commentReduce(state[action.post], action)
      });
    default:
      return state
  }
}

function commentReduce(state, action) {
  switch (action.type) {
    case types.REQUEST_COMMENT_LIST:
      return {
        ...state,
        isFetching: true,
      };

    case types.RECEIVE_COMMENT_LIST:
      return {
        ...state,
        list: action.data,
        isFetching: false,
      };
    default:
      return state;
  }
}

const commentList = combineReducers({
  listByPost
});

export default commentList;